# Testing Engineer Interview Questions

Testing engineer interview questions shared by candidates

## Top Interview Questions

Assume a matrix of integers they are sorted in boh row and column vice .. how do u find a given number from the matrix in a optimal way? Let the matrix is n*m matrix. Then O(n log m) solution is trivial (binary search in each row). There is a easy O(n+m) solution too. The idea is to start from upper right corner (mat[0][m-1]) and traverse toward lower left corner (mat[n-1][0]). On the way check each entry and depending on whether larger go left or down. If there is a solution you will find it on the way. Or you will arrive to a point where you can no longer move without going out of the matrix. Either way you will check at most O(n+m) entries thus the solution in O(n+m). I think it could be done even better than in O(n+m). Instead of starting at the upper right corner do a binary search on last column and find the biggest element that is still smaller than the given number. Say it's gonna be A[i, m-1]. Now we could throw away all rows up to an including i (since A[i, m-1] is larger than all of these elements) and the last column. Repeat everything for a smaller matrix of size (n - i, m - 1); To elaborate a little on dp's idea and add my take on it I would do a binary search on the last column to find the interval where the number is in. This interval will be one row within the matrix (assuming the value is not in the last column) and to find the interval should be O(log n). Then I would do a binary search on the row that remains which should cost O(log m). Combined that would be O(log n) + O(log m). Let me know what you guys think of this solution. Show more responses |

The most surprising part was that i was even asked questions about the basic electronics in the interview round as my branch was ECE... |

Consider a stack of N number of cards which are piled up and in facing down. Each card has a unique number from the range 1 to N. The card is stacked in such a way that it exhibits the following behavior: Take the first card and put it under the stack without revealing. Now the next card on the top will have the number 1 on it. Next take 2 cards one after the other and put is under the stack without revealing. Yes you guessed it right - the next card on the top will reveal a value of 2. This goes on. Eg. for such a series : 9,1,8,5,2,4,7,6,3,10 [for N=10] Write a program to generate such a series for a given N number of cards so that this behavior can be exercised. |

Sorting Algorithms Optimizations from 2 loops to just 1 loop |

In a sequence of alphabets (like aaabbddaabbcc) write a program to find the number of the consecutive alphabets in and print the alphabet and number. example :if input is aaabbddaabbcc then output should be 3a, 2b, 2d, 2a, 2b, 2c |

Technical questions |

Questions were based on HDL programming, which was totally unexpected, considering that it was for a software position |

Did you ever get a chance to give the estimates and how would you do that? |

given a linked list which has two types of pointers, a normal next pointer which points to next element in the list and random pointer which points to random element in the list. Question was to clone this linked list |

What is your area of interest |

**1**–

**10**of

**3,997**Interview Questions

## See Interview Questions for Similar Jobs

- Software Engineer
- Test Engineer
- QA Engineer
- Software Development Engineer In Test
- Senior Software Engineer
- Software Test Engineer
- Software Development Engineer
- Software Development Engineer In Test (SDET)
- Software Developer
- Senior QA Engineer
- Business Analyst
- Analyst
- Quality Assurance Engineer
- Software QA Engineer
- Software Engineer II
- Senior Software Developer
- QA Analyst